/* CHECKER3.C -- Mouse Hit-Test Demo Program No. 3 */

#ifdef MEWEL
#include <window.h>
#undef NULL
#define NULL 0
#else
#include <windows.h>
#endif

#define DIVISIONS 5

long FAR PASCAL WndProc      (HWND, unsigned, WORD, LONG) ;
long FAR PASCAL ChildWndProc (HWND, unsigned, WORD, LONG) ;

char szChildClass [] = "Checker3_Child" ;

int PASCAL WinMain (hInstance, hPrevInstance, lpszCmdLine, nCmdShow)
     HANDLE      hInstance, hPrevInstance ;
     LPSTR       lpszCmdLine ;
     int         nCmdShow ;
     {
     static char szAppName [] = "Checker3" ;
     HWND        hWnd ;
     MSG         msg ;
     WNDCLASS    wndclass ;

     if (!hPrevInstance) 
          {
          wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
          wndclass.lpfnWndProc   = WndProc ;
          wndclass.cbClsExtra    = 0 ;
          wndclass.cbWndExtra    = 0 ;
          wndclass.hInstance     = hInstance ;
          wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
          wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
          wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
          wndclass.lpszMenuName  = NULL ;
          wndclass.lpszClassName = szAppName ;

          if (!RegisterClass (&wndclass))
               return FALSE ;

          wndclass.lpfnWndProc   = ChildWndProc ;
          wndclass.cbWndExtra    = sizeof (WORD) ;
          wndclass.hIcon         = NULL ;
          wndclass.lpszClassName = szChildClass ;

          if (!RegisterClass (&wndclass))
               return FALSE ;
          }

     hWnd = CreateWindow (szAppName, "Checker3 Mouse Hit-Test Demo",
                         WS_OVERLAPPEDWINDOW,
                         CW_USEDEFAULT, 0,
                         CW_USEDEFAULT, 0,
                         NULL, NULL, hInstance, NULL) ;

     ShowWindow (hWnd, nCmdShow) ;
     UpdateWindow (hWnd) ;

     while (GetMessage (&msg, NULL, 0, 0))
          {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
          }
     return msg.wParam ;
     }

long FAR PASCAL WndProc (hWnd, iMessage, wParam, lParam)
     HWND        hWnd ;
     unsigned    iMessage ;
     WORD        wParam ;
     LONG        lParam ;
     {
     static HWND hChild [DIVISIONS] [DIVISIONS] ;
     short       xBlock, yBlock, x, y ;

     switch (iMessage)
          {
          case WM_CREATE:
               for (x = 0 ; x < DIVISIONS ; x++)
                    for (y = 0 ; y < DIVISIONS ; y++)
                         {
                         hChild [x][y] = CreateWindow (szChildClass, NULL,
                              WS_CHILDWINDOW | WS_VISIBLE,
                              0, 0, 0, 0,
                              hWnd, y << 8 | x,
                              GetWindowWord (hWnd, GWW_HINSTANCE), NULL) ;
                         }
               break ;

          case WM_SIZE:
#ifdef MEWEL
               xBlock = (LOWORD (lParam) * FONT_WIDTH - 1) / DIVISIONS ;
               yBlock = (HIWORD (lParam) * VideoInfo.yFontHeight - 1) / DIVISIONS ;
#else
               xBlock = LOWORD (lParam) / DIVISIONS ;
               yBlock = HIWORD (lParam) / DIVISIONS ;
#endif

               for (x = 0 ; x < DIVISIONS ; x++)
                    for (y = 0 ; y < DIVISIONS ; y++)
                         MoveWindow (hChild [x][y],
#ifdef MEWEL
                              x, y, LOWORD (lParam) / DIVISIONS, HIWORD (lParam) / DIVISIONS, TRUE) ;
#else
                              x * xBlock, y * yBlock, xBlock, yBlock, TRUE) ;
#endif
               break ;

          case WM_LBUTTONDOWN:
               MessageBeep (0) ;
               break ;

          case WM_DESTROY:
               PostQuitMessage (0) ;
               break ;

          default:
               return DefWindowProc (hWnd, iMessage, wParam, lParam) ;
          }
     return 0L ;
     }

long FAR PASCAL ChildWndProc (hWnd, iMessage, wParam, lParam)
     HWND        hWnd ;
     unsigned    iMessage ;
     WORD        wParam ;
     LONG        lParam ;
     {
     HDC         hDC ;
     PAINTSTRUCT ps ;
     RECT        rect ;

     switch (iMessage)
          {
          case WM_CREATE:
               SetWindowWord (hWnd, 0, 0) ;       /* on/off flag */
               break ;

          case WM_LBUTTONDOWN:
               SetWindowWord (hWnd, 0, 1 ^ GetWindowWord (hWnd, 0)) ;
               InvalidateRect (hWnd, NULL, FALSE) ;
               break ;

          case WM_PAINT:
               hDC = BeginPaint (hWnd, &ps) ;

               GetClientRect (hWnd, &rect) ;
#ifdef MEWEL
               _ClientRectToPixels(&rect);
#endif
               Rectangle (hDC, 0, 0, rect.right, rect.bottom) ;

               if (GetWindowWord (hWnd, 0))
                    {
                    MoveTo (hDC, 0,          0) ;
                    LineTo (hDC, rect.right, rect.bottom) ;
                    MoveTo (hDC, 0,          rect.bottom) ;
                    LineTo (hDC, rect.right, 0) ;
                    }

               EndPaint (hWnd, &ps) ;
               break ;

          default:
               return DefWindowProc (hWnd, iMessage, wParam, lParam) ;
          }
     return 0L ;
     }

#ifdef MEWEL
main(argc, argv) 
  int  argc;  char **argv; 
{ 
  char achCmdLine[128]; 
  int  i; 
  (void) argc;  (void) argv; 
  achCmdLine[0] = '0'; 
  for (i = 1;  i < argc;  i++) 
  { 
    strcat(achCmdLine, argv[i]); 
    strcat(achCmdLine, " "); 
  } 
  SetWindowsCompatibility(WC_NORMALIZE_MOUSE | WC_USE_NCMOUSE | WC_USE_WM_KEYDOWN);
  WinInit(); 
  WinUseSysColors(NULLHWND, TRUE); 
  if (WinOpenGraphics(0x10) != TRUE)
  {
    MessageBox(NULLHWND, "Can't go into graphics mode", "Checker", MB_OK);
    return -1;
  }
  i = WinMain(0, NULL, (LPSTR) achCmdLine, SW_SHOW); 
  WinCloseGraphics();
  return i;
}
#endif



